################################################################################
#
# provision.yml
# -------------
#
# This playbook provisions a Merge portal facility. The playbook requires that
# the following variables be defined.
#
# - proxies: a list of proxy hostnames
# - masters: a list of master hostnames
# - service_workers: a list of service worker hostnames
# - xdc_workers: a list of xdc worker hostnames
# - storage_servers: a list of storage servers
# - ops_servers: a list of operations servers
# - adddress_space
#     node: the node address space
#     pod: the pod address space
#     service: the service address space
#     service_ext: the externally accessible service address space
#     external:
#       api: the api address
#       xdc: the xdc address
#       launch: the launch address
#
################################################################################

# setup ========================================================================

- hosts:  "{{
    in.proxies + 
    in.masters + 
    in.service_workers + 
    in.xdc_workers + 
    in.ops_servers +
    in.storage_servers
  }}"
  become: true
  tasks:

    - name: update all servers
      apt:
        update_cache: yes
        upgrade: dist

- hosts: "{{ 
    in.proxies + 
    in.masters + 
    in.service_workers + 
    in.xdc_workers + 
    in.ops_servers +
    in.storage_servers
  }}"
  become: true
  tasks:

    - reboot:
      when: ansible_kernel is version('5.6', '<')


# keygen =======================================================================

- hosts: "localhost"
  become: true
  tasks:

    - include_tasks: keygen.yml

# proxies ======================================================================
#
- hosts: "{{ in.proxies }}"
  become: true
  tasks:

    - include_tasks: proxy.yml
 
# masters ======================================================================

- hosts: "{{ in.masters }}"
  become: true
  tasks:

    - include_tasks: master.yml

- hosts: "{{ in.masters[0] }}"
  become: true
  tasks:

    - include_tasks: kube-setup.yml
    - include_tasks: k8s-setup.yml

# workers ======================================================================

- hosts: "{{ in.service_workers + in.xdc_workers }}"
  become: true
  tasks:

    - include_tasks: worker.yml

- hosts: "{{ in.xdc_workers }}"
  become: true
  tasks:

    - include_tasks: xdc-worker.yml
